/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         __qos_parser_parse
#define yylex           __qos_parser_lex
#define yyerror         __qos_parser_error
#define yydebug         __qos_parser_debug
#define yynerrs         __qos_parser_nerrs

#define yylval          __qos_parser_lval
#define yychar          __qos_parser_char

/* Copy the first part of user declarations.  */
#line 1 "./osm_qos_parser_y.y" /* yacc.c:339  */

/*
 * Copyright (c) 2021-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * Copyright (c) 2004-2009 Voltaire, Inc. All rights reserved.
 * Copyright (c) 2002-2008 Mellanox Technologies LTD. All rights reserved.
 * Copyright (c) 1996-2003 Intel Corporation. All rights reserved.
 * Copyright (c) 2008 HNR Consulting. All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/*
 * Abstract:
 *    Grammar of OSM QoS parser.
 *
 * Environment:
 *    Linux User Mode
 *
 * Author:
 *    Yevgeny Kliteynik, Mellanox
 */

#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <opensm/osm_file_ids.h>
#define FILE_ID OSM_FILE_QOS_PARSER_Y_Y
#include <opensm/osm_opensm.h>
#include <opensm/osm_qos_policy.h>
#include <opensm/osm_helper.h>

#define OSM_QOS_POLICY_MAX_LINE_LEN         1024*10
#define OSM_QOS_POLICY_SL2VL_TABLE_LEN      IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_VL_NUM           IB_MAX_NUM_VLS
#define OSM_QOS_POLICY_MAX_RATE             IB_MAX_RATE
#define OSM_QOS_POLICY_MIN_RATE             IB_MIN_RATE
#define OSM_QOS_POLICY_MAX_MTU              IB_MAX_MTU
#define OSM_QOS_POLICY_MIN_MTU              IB_MIN_MTU

typedef struct tmp_parser_struct_t_ {
    char       str[OSM_QOS_POLICY_MAX_LINE_LEN];
    uint64_t   num_pair[2];
    ib_gid_t   gid_pair[2];
    cl_list_t  str_list;
    cl_list_t  num_list;
    cl_list_t  num_pair_list;
} tmp_parser_struct_t;

static void __parser_tmp_struct_init();
static void __parser_tmp_struct_reset();
static void __parser_tmp_struct_destroy();

static char * __parser_strip_white(char * str);

static void __make_num(uint64_t num);
static void __make_num_pair(uint64_t num_1, uint64_t num_2, boolean_t order);
static void __parser_str2uint64(uint64_t * p_val, char * str);

static void __parser_port_group_start();
static int __parser_port_group_end();

static void __parser_sl2vl_scope_start();
static int __parser_sl2vl_scope_end();

static void __parser_vlarb_scope_start();
static int __parser_vlarb_scope_end();

static void __parser_qos_level_start();
static int __parser_qos_level_end();

static void __parser_match_rule_start();
static int __parser_match_rule_end();

static void __parser_ulp_match_rule_start();
static int __parser_ulp_match_rule_end();

static void __make_gid_pair(ib_gid_t gid_1, ib_gid_t gid_2);
static void __parser_str2gid(ib_gid_t * p_val, char * str);

static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len);

inline static int __cmp_gids(ib_gid_t gid1, ib_gid_t gid2);

static void __gidrangelist2rangearr(
    cl_list_t    * p_list,
    ib_gid_t  ** * p_arr,
    unsigned     * p_arr_len);

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len );

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp);

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_prefix_range_to_prefix_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned	 range_len);

static void __parser_add_gid_range_to_gid_map(
    cl_qmap_t   * p_map,
    ib_gid_t   ** p_arr,
    unsigned	  range_len);

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len);

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list);

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap);

static int __validate_pkeys(
    uint64_t ** range_arr,
    unsigned    range_len,
    boolean_t   is_ipoib);

static void __setup_simple_qos_levels();
static void __clear_simple_qos_levels();
static void __setup_ulp_match_rules();
static void __process_ulp_match_rules();
static void yyerror(const char *format, ...);

extern char * yytext;
extern int yylex (void);
extern FILE * __qos_parser_in;
extern int __qos_parser_lex_destroy(void);
extern void __qos_parser_restart(FILE *input_file);
extern int errno;
extern YYSTYPE __qos_parser_lval;
int yyparse();

#define RESET_BUFFER  __parser_tmp_struct_reset()

tmp_parser_struct_t tmp_parser_struct;

int column_num;
int line_num;

osm_qos_policy_t       * p_qos_policy = NULL;
osm_qos_port_group_t   * p_current_port_group = NULL;
osm_qos_sl2vl_scope_t  * p_current_sl2vl_scope = NULL;
osm_qos_vlarb_scope_t  * p_current_vlarb_scope = NULL;
osm_qos_level_t        * p_current_qos_level = NULL;
osm_qos_match_rule_t   * p_current_qos_match_rule = NULL;
osm_log_t              * p_qos_parser_osm_log;

/* 16 Simple QoS Levels - one for each SL */
static osm_qos_level_t osm_qos_policy_simple_qos_levels[16];

/* Default Simple QoS Level */
osm_qos_level_t __default_simple_qos_level;

/*
 * List of match rules that will be generated by the
 * qos-ulp section. These rules are concatenated to
 * the end of the usual matching rules list at the
 * end of parsing.
 */
static cl_list_t __ulp_match_rules;

/* Temporary variables for parsing */
static ib_gid_t gid_1, gid_2, gid_tmp;
static uint64_t num_1, num_2, num_tmp;

/***************************************************/


#line 298 "./osm_qos_parser_y.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "osm_qos_parser_y.h".  */
#ifndef YY__QOS_PARSER_OSM_QOS_PARSER_Y_H_INCLUDED
# define YY__QOS_PARSER_OSM_QOS_PARSER_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int __qos_parser_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ERROR = 258,
    TK_NUMBER = 259,
    TK_DASH = 260,
    TK_DOTDOT = 261,
    TK_COMMA = 262,
    TK_ASTERISK = 263,
    TK_TEXT = 264,
    TK_IPV6_ADDR = 265,
    TK_QOS_ULPS_START = 266,
    TK_QOS_ULPS_END = 267,
    TK_PORT_GROUPS_START = 268,
    TK_PORT_GROUPS_END = 269,
    TK_PORT_GROUP_START = 270,
    TK_PORT_GROUP_END = 271,
    TK_QOS_SETUP_START = 272,
    TK_QOS_SETUP_END = 273,
    TK_VLARB_TABLES_START = 274,
    TK_VLARB_TABLES_END = 275,
    TK_VLARB_SCOPE_START = 276,
    TK_VLARB_SCOPE_END = 277,
    TK_SL2VL_TABLES_START = 278,
    TK_SL2VL_TABLES_END = 279,
    TK_SL2VL_SCOPE_START = 280,
    TK_SL2VL_SCOPE_END = 281,
    TK_QOS_LEVELS_START = 282,
    TK_QOS_LEVELS_END = 283,
    TK_QOS_LEVEL_START = 284,
    TK_QOS_LEVEL_END = 285,
    TK_QOS_MATCH_RULES_START = 286,
    TK_QOS_MATCH_RULES_END = 287,
    TK_QOS_MATCH_RULE_START = 288,
    TK_QOS_MATCH_RULE_END = 289,
    TK_NAME = 290,
    TK_USE = 291,
    TK_PORT_GUID = 292,
    TK_PORT_GID = 293,
    TK_SUBNET_PREFIX = 294,
    TK_PORT_NAME = 295,
    TK_PARTITION = 296,
    TK_NODE_TYPE = 297,
    TK_GROUP = 298,
    TK_ACROSS = 299,
    TK_VLARB_HIGH = 300,
    TK_VLARB_LOW = 301,
    TK_VLARB_HIGH_LIMIT = 302,
    TK_TO = 303,
    TK_FROM = 304,
    TK_ACROSS_TO = 305,
    TK_ACROSS_FROM = 306,
    TK_SL2VL_TABLE = 307,
    TK_SL = 308,
    TK_MTU_LIMIT = 309,
    TK_RATE_LIMIT = 310,
    TK_PACKET_LIFE = 311,
    TK_PATH_BITS = 312,
    TK_QOS_CLASS = 313,
    TK_SOURCE = 314,
    TK_DESTINATION = 315,
    TK_SERVICE_ID = 316,
    TK_QOS_LEVEL_NAME = 317,
    TK_PKEY = 318,
    TK_NODE_TYPE_ROUTER = 319,
    TK_NODE_TYPE_CA = 320,
    TK_NODE_TYPE_SWITCH = 321,
    TK_NODE_TYPE_SELF = 322,
    TK_NODE_TYPE_ALL = 323,
    TK_ULP_DEFAULT = 324,
    TK_ULP_ANY_SERVICE_ID = 325,
    TK_ULP_ANY_PKEY = 326,
    TK_ULP_ANY_TARGET_PORT_GUID = 327,
    TK_ULP_ANY_SOURCE_PORT_GUID = 328,
    TK_ULP_ANY_SOURCE_TARGET_PORT_GUID = 329,
    TK_ULP_ANY_TARGET_SUBNET_PREFIX = 330,
    TK_ULP_SDP_DEFAULT = 331,
    TK_ULP_SDP_PORT = 332,
    TK_ULP_RDS_DEFAULT = 333,
    TK_ULP_RDS_PORT = 334,
    TK_ULP_ISER_DEFAULT = 335,
    TK_ULP_ISER_PORT = 336,
    TK_ULP_SRP_GUID = 337,
    TK_ULP_IPOIB_DEFAULT = 338,
    TK_ULP_IPOIB_PKEY = 339
  };
#endif
/* Tokens.  */
#define ERROR 258
#define TK_NUMBER 259
#define TK_DASH 260
#define TK_DOTDOT 261
#define TK_COMMA 262
#define TK_ASTERISK 263
#define TK_TEXT 264
#define TK_IPV6_ADDR 265
#define TK_QOS_ULPS_START 266
#define TK_QOS_ULPS_END 267
#define TK_PORT_GROUPS_START 268
#define TK_PORT_GROUPS_END 269
#define TK_PORT_GROUP_START 270
#define TK_PORT_GROUP_END 271
#define TK_QOS_SETUP_START 272
#define TK_QOS_SETUP_END 273
#define TK_VLARB_TABLES_START 274
#define TK_VLARB_TABLES_END 275
#define TK_VLARB_SCOPE_START 276
#define TK_VLARB_SCOPE_END 277
#define TK_SL2VL_TABLES_START 278
#define TK_SL2VL_TABLES_END 279
#define TK_SL2VL_SCOPE_START 280
#define TK_SL2VL_SCOPE_END 281
#define TK_QOS_LEVELS_START 282
#define TK_QOS_LEVELS_END 283
#define TK_QOS_LEVEL_START 284
#define TK_QOS_LEVEL_END 285
#define TK_QOS_MATCH_RULES_START 286
#define TK_QOS_MATCH_RULES_END 287
#define TK_QOS_MATCH_RULE_START 288
#define TK_QOS_MATCH_RULE_END 289
#define TK_NAME 290
#define TK_USE 291
#define TK_PORT_GUID 292
#define TK_PORT_GID 293
#define TK_SUBNET_PREFIX 294
#define TK_PORT_NAME 295
#define TK_PARTITION 296
#define TK_NODE_TYPE 297
#define TK_GROUP 298
#define TK_ACROSS 299
#define TK_VLARB_HIGH 300
#define TK_VLARB_LOW 301
#define TK_VLARB_HIGH_LIMIT 302
#define TK_TO 303
#define TK_FROM 304
#define TK_ACROSS_TO 305
#define TK_ACROSS_FROM 306
#define TK_SL2VL_TABLE 307
#define TK_SL 308
#define TK_MTU_LIMIT 309
#define TK_RATE_LIMIT 310
#define TK_PACKET_LIFE 311
#define TK_PATH_BITS 312
#define TK_QOS_CLASS 313
#define TK_SOURCE 314
#define TK_DESTINATION 315
#define TK_SERVICE_ID 316
#define TK_QOS_LEVEL_NAME 317
#define TK_PKEY 318
#define TK_NODE_TYPE_ROUTER 319
#define TK_NODE_TYPE_CA 320
#define TK_NODE_TYPE_SWITCH 321
#define TK_NODE_TYPE_SELF 322
#define TK_NODE_TYPE_ALL 323
#define TK_ULP_DEFAULT 324
#define TK_ULP_ANY_SERVICE_ID 325
#define TK_ULP_ANY_PKEY 326
#define TK_ULP_ANY_TARGET_PORT_GUID 327
#define TK_ULP_ANY_SOURCE_PORT_GUID 328
#define TK_ULP_ANY_SOURCE_TARGET_PORT_GUID 329
#define TK_ULP_ANY_TARGET_SUBNET_PREFIX 330
#define TK_ULP_SDP_DEFAULT 331
#define TK_ULP_SDP_PORT 332
#define TK_ULP_RDS_DEFAULT 333
#define TK_ULP_RDS_PORT 334
#define TK_ULP_ISER_DEFAULT 335
#define TK_ULP_ISER_PORT 336
#define TK_ULP_SRP_GUID 337
#define TK_ULP_IPOIB_DEFAULT 338
#define TK_ULP_IPOIB_PKEY 339

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE __qos_parser_lval;

int __qos_parser_parse (void);

#endif /* !YY__QOS_PARSER_OSM_QOS_PARSER_Y_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 517 "./osm_qos_parser_y.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   338

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  85
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  179
/* YYNRULES -- Number of rules.  */
#define YYNRULES  258
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  357

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   339

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   322,   322,   325,   326,   329,   330,   331,   332,   333,
     359,   362,   363,   392,   395,   396,   399,   402,   407,   413,
     414,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     452,   455,   456,   457,   462,   465,   466,   469,   472,   477,
     483,   484,   499,   500,   501,   502,   503,   508,   511,   512,
     515,   518,   523,   529,   530,   549,   550,   551,   552,   553,
     554,   555,   579,   582,   583,   586,   589,   594,   600,   601,
     604,   605,   606,   607,   608,   609,   610,   611,   633,   636,
     637,   640,   643,   648,   654,   655,   658,   659,   660,   661,
     662,   663,   664,   688,   706,   706,   727,   727,   748,   748,
     783,   783,   818,   818,   856,   856,   892,   892,   905,   905,
     939,   939,   952,   952,   986,   986,   999,   999,  1033,  1033,
    1069,  1069,  1092,  1092,  1125,  1128,  1131,  1134,  1137,  1140,
    1143,  1146,  1149,  1152,  1155,  1158,  1161,  1164,  1167,  1171,
    1210,  1233,  1238,  1261,  1266,  1332,  1337,  1357,  1362,  1382,
    1387,  1406,  1412,  1432,  1437,  1445,  1450,  1455,  1460,  1461,
    1464,  1465,  1466,  1467,  1468,  1471,  1477,  1483,  1489,  1497,
    1519,  1536,  1541,  1558,  1563,  1581,  1586,  1603,  1608,  1625,
    1641,  1658,  1663,  1682,  1687,  1704,  1709,  1727,  1732,  1737,
    1742,  1747,  1752,  1753,  1756,  1763,  1764,  1767,  1774,  1805,
    1837,  1880,  1897,  1920,  1925,  1948,  1953,  1973,  1978,  2005,
    2011,  2038,  2044,  2064,  2070,  2105,  2110,  2143,  2160,  2183,
    2188,  2222,  2227,  2244,  2249,  2266,  2271,  2294,  2299,  2332,
    2337,  2370,  2381,  2388,  2389,  2392,  2401,  2402,  2407,  2408,
    2411,  2414,  2419,  2420,  2423,  2423,  2428,  2431,  2432,  2435,
    2435,  2436,  2441,  2444,  2445,  2448,  2448,  2449,  2452
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ERROR", "TK_NUMBER", "TK_DASH",
  "TK_DOTDOT", "TK_COMMA", "TK_ASTERISK", "TK_TEXT", "TK_IPV6_ADDR",
  "TK_QOS_ULPS_START", "TK_QOS_ULPS_END", "TK_PORT_GROUPS_START",
  "TK_PORT_GROUPS_END", "TK_PORT_GROUP_START", "TK_PORT_GROUP_END",
  "TK_QOS_SETUP_START", "TK_QOS_SETUP_END", "TK_VLARB_TABLES_START",
  "TK_VLARB_TABLES_END", "TK_VLARB_SCOPE_START", "TK_VLARB_SCOPE_END",
  "TK_SL2VL_TABLES_START", "TK_SL2VL_TABLES_END", "TK_SL2VL_SCOPE_START",
  "TK_SL2VL_SCOPE_END", "TK_QOS_LEVELS_START", "TK_QOS_LEVELS_END",
  "TK_QOS_LEVEL_START", "TK_QOS_LEVEL_END", "TK_QOS_MATCH_RULES_START",
  "TK_QOS_MATCH_RULES_END", "TK_QOS_MATCH_RULE_START",
  "TK_QOS_MATCH_RULE_END", "TK_NAME", "TK_USE", "TK_PORT_GUID",
  "TK_PORT_GID", "TK_SUBNET_PREFIX", "TK_PORT_NAME", "TK_PARTITION",
  "TK_NODE_TYPE", "TK_GROUP", "TK_ACROSS", "TK_VLARB_HIGH", "TK_VLARB_LOW",
  "TK_VLARB_HIGH_LIMIT", "TK_TO", "TK_FROM", "TK_ACROSS_TO",
  "TK_ACROSS_FROM", "TK_SL2VL_TABLE", "TK_SL", "TK_MTU_LIMIT",
  "TK_RATE_LIMIT", "TK_PACKET_LIFE", "TK_PATH_BITS", "TK_QOS_CLASS",
  "TK_SOURCE", "TK_DESTINATION", "TK_SERVICE_ID", "TK_QOS_LEVEL_NAME",
  "TK_PKEY", "TK_NODE_TYPE_ROUTER", "TK_NODE_TYPE_CA",
  "TK_NODE_TYPE_SWITCH", "TK_NODE_TYPE_SELF", "TK_NODE_TYPE_ALL",
  "TK_ULP_DEFAULT", "TK_ULP_ANY_SERVICE_ID", "TK_ULP_ANY_PKEY",
  "TK_ULP_ANY_TARGET_PORT_GUID", "TK_ULP_ANY_SOURCE_PORT_GUID",
  "TK_ULP_ANY_SOURCE_TARGET_PORT_GUID", "TK_ULP_ANY_TARGET_SUBNET_PREFIX",
  "TK_ULP_SDP_DEFAULT", "TK_ULP_SDP_PORT", "TK_ULP_RDS_DEFAULT",
  "TK_ULP_RDS_PORT", "TK_ULP_ISER_DEFAULT", "TK_ULP_ISER_PORT",
  "TK_ULP_SRP_GUID", "TK_ULP_IPOIB_DEFAULT", "TK_ULP_IPOIB_PKEY",
  "$accept", "head", "qos_policy_entries", "qos_policy_entry",
  "qos_ulps_section", "qos_ulps", "port_groups_section", "port_groups",
  "port_group", "port_group_start", "port_group_end", "port_group_entries",
  "port_group_entry", "qos_setup_section", "qos_setup_items",
  "vlarb_tables", "vlarb_scope_items", "vlarb_scope", "vlarb_scope_start",
  "vlarb_scope_end", "vlarb_scope_entries", "vlarb_scope_entry",
  "sl2vl_tables", "sl2vl_scope_items", "sl2vl_scope", "sl2vl_scope_start",
  "sl2vl_scope_end", "sl2vl_scope_entries", "sl2vl_scope_entry",
  "qos_levels_section", "qos_levels", "qos_level", "qos_level_start",
  "qos_level_end", "qos_level_entries", "qos_level_entry",
  "qos_match_rules_section", "qos_match_rules", "qos_match_rule",
  "qos_match_rule_start", "qos_match_rule_end", "qos_match_rule_entries",
  "qos_match_rule_entry", "qos_ulp", "$@1", "$@2", "$@3", "$@4", "$@5",
  "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13", "$@14",
  "$@15", "qos_ulp_type_any_service", "qos_ulp_type_any_pkey",
  "qos_ulp_type_any_target_port_guid", "qos_ulp_type_any_source_port_guid",
  "qos_ulp_type_any_source_target_port_guid",
  "qos_ulp_type_any_target_subnet_prefix", "qos_ulp_type_sdp_default",
  "qos_ulp_type_sdp_port", "qos_ulp_type_rds_default",
  "qos_ulp_type_rds_port", "qos_ulp_type_iser_default",
  "qos_ulp_type_iser_port", "qos_ulp_type_srp_guid",
  "qos_ulp_type_ipoib_default", "qos_ulp_type_ipoib_pkey", "qos_ulp_sl",
  "port_group_name", "port_group_name_start", "port_group_use",
  "port_group_use_start", "port_group_port_name",
  "port_group_port_name_start", "port_group_port_guid",
  "port_group_port_guid_start", "port_group_prefix",
  "port_group_subnet_prefix_start", "port_group_gid",
  "port_group_port_gid_start", "port_group_pkey", "port_group_pkey_start",
  "port_group_partition", "port_group_partition_start",
  "port_group_node_type", "port_group_node_type_start",
  "port_group_node_type_list", "node_type_item", "node_type_ca",
  "node_type_switch", "node_type_router", "node_type_all",
  "node_type_self", "vlarb_scope_group", "vlarb_scope_group_start",
  "vlarb_scope_across", "vlarb_scope_across_start",
  "vlarb_scope_vlarb_high_limit", "vlarb_scope_vlarb_high_limit_start",
  "vlarb_scope_vlarb_high", "vlarb_scope_vlarb_high_start",
  "vlarb_scope_vlarb_low", "vlarb_scope_vlarb_low_start",
  "sl2vl_scope_group", "sl2vl_scope_group_start", "sl2vl_scope_across",
  "sl2vl_scope_across_start", "sl2vl_scope_across_from",
  "sl2vl_scope_across_from_start", "sl2vl_scope_across_to",
  "sl2vl_scope_across_to_start", "sl2vl_scope_from",
  "sl2vl_scope_from_start", "sl2vl_scope_to", "sl2vl_scope_to_start",
  "sl2vl_scope_from_list_or_asterisk", "sl2vl_scope_from_asterisk",
  "sl2vl_scope_to_list_or_asterisk", "sl2vl_scope_to_asterisk",
  "sl2vl_scope_from_list_of_ranges", "sl2vl_scope_to_list_of_ranges",
  "sl2vl_scope_sl2vl_table", "sl2vl_scope_sl2vl_table_start",
  "qos_level_name", "qos_level_name_start", "qos_level_use",
  "qos_level_use_start", "qos_level_sl", "qos_level_sl_start",
  "qos_level_mtu_limit", "qos_level_mtu_limit_start",
  "qos_level_rate_limit", "qos_level_rate_limit_start",
  "qos_level_packet_life", "qos_level_packet_life_start",
  "qos_level_path_bits", "qos_level_path_bits_start", "qos_level_pkey",
  "qos_level_pkey_start", "qos_match_rule_use", "qos_match_rule_use_start",
  "qos_match_rule_qos_class", "qos_match_rule_qos_class_start",
  "qos_match_rule_source", "qos_match_rule_source_start",
  "qos_match_rule_destination", "qos_match_rule_destination_start",
  "qos_match_rule_qos_level_name", "qos_match_rule_qos_level_name_start",
  "qos_match_rule_service_id", "qos_match_rule_service_id_start",
  "qos_match_rule_pkey", "qos_match_rule_pkey_start", "single_string",
  "single_string_elems", "single_string_element", "string_list",
  "num_list", "single_number", "number", "num_list_with_dotdot",
  "number_dotdot_pair", "$@16", "list_of_ranges", "number_range_list",
  "number_range", "$@17", "list_of_gid_ranges", "gid_list", "gid_entry",
  "$@18", "gid", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339
};
# endif

#define YYPACT_NINF -171

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-171)))

#define YYTABLE_NINF -256

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -171,     1,     8,  -171,    85,    -6,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,     7,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,    -5,  -171,     7,     7,     7,     7,     7,     7,  -171,
       7,  -171,     7,  -171,     7,     7,  -171,     7,  -171,    15,
    -171,  -171,     4,     5,     9,  -171,  -171,  -171,  -171,  -171,
      13,    31,    33,  -171,    38,    49,    51,    54,    57,     7,
      74,     7,    91,     7,    92,    94,     7,    96,  -171,  -171,
      46,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,    98,  -171,     7,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,    95,  -171,    95,  -171,    95,
    -171,     7,  -171,     7,  -171,    97,  -171,     7,  -171,    95,
    -171,    26,    75,    22,    -4,   117,     7,     7,  -171,     7,
       7,     7,     7,     7,     7,     7,     7,     7,     7,  -171,
    -171,    95,  -171,  -171,  -171,    99,  -171,  -171,  -171,  -171,
     101,  -171,   111,  -171,    99,  -171,  -171,  -171,  -171,  -171,
     126,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,    95,  -171,    95,
    -171,     7,  -171,     7,  -171,     7,  -171,     7,  -171,     7,
    -171,     7,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,    95,  -171,     7,  -171,    95,  -171,    95,
    -171,    95,  -171,     7,  -171,     7,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,    95,
      97,   140,    26,    67,   175,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,    99,    99,  -171,  -171,  -171,
    -171,  -171,    97,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,    95,  -171,    95,  -171,     7,  -171,     7,
    -171,     7,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,    95,  -171,    95,  -171,    95,  -171,    95,
    -171,    12,  -171,    20,  -171,     7,  -171,    99,    99,  -171,
    -171,   139,  -171,   139,    99,    99,    99,    99,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,   141,  -171,
     143,     7,     7,     7,  -171,  -171,  -171
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       3,     0,     2,     1,     0,     0,    31,    63,    79,     4,
       5,     6,     7,     8,     9,     0,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,     0,    11,     0,     0,     0,     0,     0,     0,   106,
       0,   110,     0,   114,     0,     0,   120,     0,    17,     0,
      14,    19,     0,     0,     0,   241,    93,   240,    10,    12,
     251,     0,   246,   248,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    13,    15,
       0,    30,    35,    48,    32,    33,    62,    66,    64,    68,
      78,    82,    80,    84,     0,    94,     0,    96,    98,   100,
     102,   104,   107,   139,   108,   111,   112,   115,   116,   118,
     121,   122,    18,   141,   143,   147,   151,   149,   145,   155,
     157,   153,    16,    20,    21,     0,    22,     0,    26,     0,
      23,     0,    24,     0,    25,     0,    27,     0,    28,     0,
      29,     0,     0,     0,     0,     0,     0,     0,   247,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     140,   232,   233,   142,   236,   144,   146,   148,   258,   150,
     252,   254,   257,   152,   154,   167,   165,   166,   169,   168,
     156,   158,   160,   161,   162,   163,   164,    34,    38,    36,
      40,    47,    51,    49,    53,    67,   203,   205,   207,   209,
     211,   213,   215,   217,    65,    69,    70,     0,    71,     0,
      72,     0,    73,     0,    74,     0,    75,     0,    76,     0,
      77,     0,    83,   219,   221,   223,   225,   229,   227,   231,
      81,    85,    86,     0,    87,     0,    89,     0,    90,     0,
      88,     0,    91,     0,    92,     0,   250,    95,    97,    99,
     101,   103,   105,   109,   113,   117,   119,   123,   234,     0,
       0,     0,     0,     0,     0,   202,   204,   206,   208,   210,
     212,   214,   216,   218,   220,   222,   224,   226,   228,   230,
     237,   253,     0,   159,    39,   171,   173,   177,   179,   175,
      37,    41,    42,     0,    43,     0,    46,     0,    44,     0,
      45,     0,    52,   181,   183,   191,   189,   187,   185,   201,
      50,    54,    55,     0,    56,     0,    57,     0,    58,     0,
      59,     0,    60,     0,    61,     0,   256,   170,   172,   174,
     244,   176,   243,   178,   180,   182,   184,   186,   194,   188,
     192,   193,   198,   197,   190,   195,   196,   199,   200,   239,
       0,     0,     0,     0,   242,   238,   245
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,   123,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,   116,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,   -28,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -112,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
     -89,  -171,    21,  -122,  -171,    -1,   -15,  -127,  -170,  -171,
     -32,  -171,    87,  -171,  -171,  -171,   -76,  -171,   -97
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     9,    10,    31,    11,    49,    50,    51,
     122,    80,   123,    12,    52,    84,   142,   189,   190,   290,
     263,   291,    85,   143,   193,   194,   310,   264,   311,    13,
      53,    88,    89,   204,   144,   205,    14,    54,    92,    93,
     230,   145,   231,    32,   147,   149,   150,   151,   152,   153,
      69,   154,    71,   155,    73,   156,   157,    76,   158,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,   102,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   180,   181,   182,   183,   184,   185,   186,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   339,   340,   344,   345,   341,   346,   324,   325,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     164,   161,   162,   165,   348,   103,    60,   331,   332,   350,
      61,    62,    63,    94,   169,   170,   171,   261,   172
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      57,     3,    64,    65,    66,    67,    68,    58,    70,    48,
      72,    55,    74,    75,    56,    77,    55,   174,  -249,     4,
     338,     5,    81,    82,    55,     6,   195,    83,   343,    78,
      48,   196,   197,    86,    87,     7,   160,    95,   163,     8,
      96,    90,    91,   105,    97,   107,   191,   192,   110,   198,
     199,   200,   201,   202,    57,    98,    57,    99,    57,   203,
     100,    57,   112,   101,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     104,   113,   114,   115,   116,   117,   118,   119,   120,   284,
     175,   176,   177,   178,   179,   187,   188,   106,   108,   166,
     109,   167,   111,   146,   159,   173,   259,   168,   260,   121,
     285,   286,   287,   288,   289,   275,  -255,   276,   265,   247,
     266,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   246,    57,   262,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,   273,   282,   351,    59,   352,   353,
     283,   222,   277,   223,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     280,   327,    79,   328,   333,   224,   225,   226,   227,   228,
     229,   354,   258,   148,   281,   326,     0,   271,     0,   272,
       0,   334,     0,   335,     0,   336,    57,   337,    57,     0,
      57,   302,    57,   274,     0,     0,     0,     0,     0,     0,
     267,   278,   268,   279,   269,     0,   270,     0,   303,   304,
       0,     0,     0,   305,   306,   307,   308,   309,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,     0,   330,     0,   330,     0,     0,   342,
       0,   347,     0,     0,     0,     0,   329,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     349,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   330,   355,   356
};

static const yytype_int16 yycheck[] =
{
      15,     0,    34,    35,    36,    37,    38,    12,    40,    15,
      42,     4,    44,    45,    15,    47,     4,   139,     5,    11,
       8,    13,    18,    19,     4,    17,    30,    23,     8,    14,
      15,    35,    36,    28,    29,    27,   125,     6,   127,    31,
       7,    32,    33,    71,     6,    73,    24,    25,    76,    53,
      54,    55,    56,    57,    69,     6,    71,     6,    73,    63,
       6,    76,    16,     6,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
       6,    35,    36,    37,    38,    39,    40,    41,    42,    22,
      64,    65,    66,    67,    68,    20,    21,     6,     6,   131,
       6,   133,     6,     5,     9,   137,     7,    10,     7,    63,
      43,    44,    45,    46,    47,   237,     5,   239,   207,   147,
     209,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   146,   147,     7,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   233,     5,     7,    31,     7,     6,
     262,    34,   241,    36,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
     259,   293,    49,   295,   301,    58,    59,    60,    61,    62,
      63,   351,   161,    96,   260,   282,    -1,   219,    -1,   221,
      -1,   313,    -1,   315,    -1,   317,   211,   319,   213,    -1,
     215,    26,   217,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     211,   243,   213,   245,   215,    -1,   217,    -1,    43,    44,
      -1,    -1,    -1,    48,    49,    50,    51,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   297,    -1,   299,    -1,   301,    -1,    -1,   321,
      -1,   323,    -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   351,   352,   353
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    86,    87,     0,    11,    13,    17,    27,    31,    88,
      89,    91,    98,   114,   121,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    90,   128,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    15,    92,
      93,    94,    99,   115,   122,     4,   250,   251,    12,   128,
     251,   255,   256,   257,   255,   255,   255,   255,   255,   135,
     255,   137,   255,   139,   255,   255,   142,   255,    14,    93,
      96,    18,    19,    23,   100,   107,    28,    29,   116,   117,
      32,    33,   123,   124,   258,     6,     7,     6,     6,     6,
       6,     6,   159,   250,     6,   159,     6,   159,     6,     6,
     159,     6,    16,    35,    36,    37,    38,    39,    40,    41,
      42,    63,    95,    97,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   101,   108,   119,   126,     5,   129,   257,   130,
     131,   132,   133,   134,   136,   138,   140,   141,   143,     9,
     245,   246,   247,   245,   245,   248,   255,   255,    10,   259,
     260,   261,   263,   255,   248,    64,    65,    66,    67,    68,
     178,   179,   180,   181,   182,   183,   184,    20,    21,   102,
     103,    24,    25,   109,   110,    30,    35,    36,    53,    54,
      55,    56,    57,    63,   118,   120,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,    34,    36,    58,    59,    60,    61,    62,    63,
     125,   127,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   251,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   247,     7,
       7,   262,     7,   105,   112,   245,   245,   250,   250,   250,
     250,   255,   255,   245,   255,   248,   248,   245,   255,   255,
     245,   261,     5,   179,    22,    43,    44,    45,    46,    47,
     104,   106,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,    26,    43,    44,    48,    49,    50,    51,    52,
     111,   113,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   213,   214,   263,   248,   248,   250,
     251,   252,   253,   252,   248,   248,   248,   248,     8,   207,
     208,   211,   255,     8,   209,   210,   212,   255,   249,   251,
     254,     7,     7,     6,   253,   251,   251
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,    85,    86,    87,    87,    88,    88,    88,    88,    88,
      89,    90,    90,    91,    92,    92,    93,    94,    95,    96,
      96,    97,    97,    97,    97,    97,    97,    97,    97,    97,
      98,    99,    99,    99,   100,   101,   101,   102,   103,   104,
     105,   105,   106,   106,   106,   106,   106,   107,   108,   108,
     109,   110,   111,   112,   112,   113,   113,   113,   113,   113,
     113,   113,   114,   115,   115,   116,   117,   118,   119,   119,
     120,   120,   120,   120,   120,   120,   120,   120,   121,   122,
     122,   123,   124,   125,   126,   126,   127,   127,   127,   127,
     127,   127,   127,   128,   129,   128,   130,   128,   131,   128,
     132,   128,   133,   128,   134,   128,   135,   128,   136,   128,
     137,   128,   138,   128,   139,   128,   140,   128,   141,   128,
     142,   128,   143,   128,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   178,
     179,   179,   179,   179,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   207,   208,   209,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   246,   247,   248,   248,   249,   249,
     250,   251,   252,   252,   254,   253,   255,   256,   256,   258,
     257,   257,   259,   260,   260,   262,   261,   261,   263
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       3,     1,     2,     3,     1,     2,     3,     1,     1,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     0,     2,     2,     3,     0,     2,     3,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     3,     0,     2,
       3,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     3,     0,     2,     3,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     0,
       2,     3,     1,     1,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     2,     0,     5,     0,     5,     0,     5,
       0,     5,     0,     5,     0,     5,     0,     3,     0,     5,
       0,     3,     0,     5,     0,     3,     0,     5,     0,     5,
       0,     3,     0,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       2,     1,     1,     1,     2,     1,     1,     3,     3,     1,
       1,     1,     3,     1,     0,     4,     1,     3,     1,     0,
       4,     1,     1,     3,     1,     0,     4,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 17:
#line 402 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_port_group_start();
                    }
#line 1967 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 18:
#line 407 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_port_group_end() )
                            return 1;
                    }
#line 1976 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 38:
#line 472 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_vlarb_scope_start();
                    }
#line 1984 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 39:
#line 477 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_vlarb_scope_end() )
                            return 1;
                    }
#line 1993 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 51:
#line 518 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_sl2vl_scope_start();
                    }
#line 2001 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 52:
#line 523 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_sl2vl_scope_end() )
                            return 1;
                    }
#line 2010 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 66:
#line 589 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_qos_level_start();
                    }
#line 2018 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 67:
#line 594 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_qos_level_end() )
                            return 1;
                    }
#line 2027 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 82:
#line 643 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        __parser_match_rule_start();
                    }
#line 2035 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 83:
#line 648 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        if ( __parser_match_rule_end() )
                            return 1;
                    }
#line 2044 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 93:
#line 688 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* parsing default ulp rule: "default: num" */
                        cl_list_iterator_t    list_iterator;
                        uint64_t            * p_tmp_num;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }
                        __default_simple_qos_level.sl = (uint8_t)(*p_tmp_num);
                        __default_simple_qos_level.sl_set = TRUE;
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);
                    }
#line 2066 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 94:
#line 706 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "any, service-id ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have service ids");
                            return 1;
                        }

                        /* get all the service id ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2091 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 96:
#line 727 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "any, pkey ... : sl" - one instance of list of ranges */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2116 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 98:
#line 748 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* any, target-port-guid ... : sl */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2155 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 100:
#line 783 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			/* any, source-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2194 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 102:
#line 818 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			/* any, source-target-port-guid ... : sl */
			uint64_t ** range_arr;
			unsigned    range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list))
			{
				yyerror("ULP rule doesn't have port guids");
				return 1;
			}

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Sources_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the source and destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->source_group_list,
                                            p_current_port_group);

                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2236 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 104:
#line 856 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			uint64_t ** range_arr;
			unsigned range_len;

			if (!cl_list_count(&tmp_parser_struct.num_pair_list)) {
				yyerror("ULP rule doesn't have subnet prefixes");
				return 1;
			}

                        /* create a new port group with these prefixes */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_ULP_Targets_");
                        p_current_port_group->use =
			    strdup("Generated from ULP rules");
			__rangelist2rangearr(&tmp_parser_struct.num_pair_list,
					     &range_arr,
					     &range_len);

			__parser_add_prefix_range_to_prefix_map(
			    &p_current_port_group->prefix_map,
			    range_arr,
			    range_len);

                        /*
			 * Add this port group to the destination groups of
			 * current match rule
			 */
                        cl_list_insert_tail(&p_current_qos_match_rule->
					    destination_group_list,
					    p_current_port_group);

                        __parser_port_group_end();

		    }
#line 2276 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 106:
#line 892 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "sdp : sl" - default SL for SDP */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        range_arr[0][1] = OSM_QOS_POLICY_ULP_SDP_SERVICE_ID + 0xFFFF;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2293 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 108:
#line 905 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* sdp with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SDP ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_SDP_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2331 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 110:
#line 939 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "rds : sl" - default SL for RDS */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_RDS_SERVICE_ID + OSM_QOS_POLICY_ULP_RDS_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2348 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 112:
#line 952 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* rds with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("RDS ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_RDS_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2386 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 114:
#line 986 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* "iSER : sl" - default SL for iSER */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] =
                           OSM_QOS_POLICY_ULP_ISER_SERVICE_ID + OSM_QOS_POLICY_ULP_ISER_PORT;

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = 1;

                    }
#line 2403 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 116:
#line 999 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* iser with port numbers */
                        uint64_t ** range_arr;
                        unsigned    range_len;
                        unsigned    i;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("iSER ULP rule doesn't have port numbers");
                            return 1;
                        }

                        /* get all the port ranges */
                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );
                        /* now translate these port numbers into service ids */
                        for (i = 0; i < range_len; i++)
                        {
                            if (range_arr[i][0] > 0xFFFF || range_arr[i][1] > 0xFFFF)
                            {
                                yyerror("SDP port number out of range");
				free(range_arr);
                                return 1;
                            }
                            range_arr[i][0] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                            range_arr[i][1] += OSM_QOS_POLICY_ULP_ISER_SERVICE_ID;
                        }

                        p_current_qos_match_rule->service_id_range_arr = range_arr;
                        p_current_qos_match_rule->service_id_range_len = range_len;

                    }
#line 2441 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1033 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* srp with target guids - this rule is similar
                           to writing 'any' ulp with target port guids */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("SRP ULP rule doesn't have port guids");
                            return 1;
                        }

                        /* create a new port group with these ports */
                        __parser_port_group_start();

                        p_current_port_group->name = strdup("_SRP_Targets_");
                        p_current_port_group->use = strdup("Generated from ULP rules");

                        __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        __parser_add_guid_range_to_port_map(
                                              &p_current_port_group->port_map,
                                              range_arr,
                                              range_len);

                        /* add this port group to the destination
                           groups of the current match rule */
                        cl_list_insert_tail(&p_current_qos_match_rule->destination_group_list,
                                            p_current_port_group);

                        __parser_port_group_end();

                    }
#line 2481 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1069 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* ipoib w/o any pkeys (default pkey) */
                        uint64_t ** range_arr =
                               (uint64_t **)malloc(sizeof(uint64_t *));
                        range_arr[0] = (uint64_t *)malloc(2*sizeof(uint64_t));
                        range_arr[0][0] = range_arr[0][1] = 0x7fff;

                        /*
                         * Although we know that the default partition exists,
                         * we still need to validate it by checking that it has
                         * at least two full members. Otherwise IPoIB won't work.
                         */
                        if (__validate_pkeys(range_arr, 1, TRUE)) {
                            free(range_arr[0]);
                            free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = 1;

                    }
#line 2508 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1092 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* ipoib with pkeys */
                        uint64_t ** range_arr;
                        unsigned    range_len;

                        if (!cl_list_count(&tmp_parser_struct.num_pair_list))
                        {
                            yyerror("IPoIB ULP rule doesn't have pkeys");
                            return 1;
                        }

                        /* get all the pkey ranges */
                        __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                              &range_arr,
                                              &range_len );

                        /*
                         * Validate pkeys.
                         * For IPoIB pkeys the validation is strict.
                         * If some problem would be found, parsing will
                         * be aborted with a proper error messages.
                         */
			if (__validate_pkeys(range_arr, range_len, TRUE)) {
			    free(range_arr);
                            return 1;
			}

                        p_current_qos_match_rule->pkey_range_arr = range_arr;
                        p_current_qos_match_rule->pkey_range_len = range_len;

                    }
#line 2544 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1126 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2550 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1129 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2556 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1132 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2562 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1135 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2568 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1138 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2574 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1141 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2580 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1144 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2586 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1147 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2592 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1150 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2598 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1153 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2604 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1156 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2610 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1159 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2616 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1162 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2622 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1165 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2628 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1168 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_ulp_match_rule_start(); }
#line 2634 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1171 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        /* get the SL for ULP rules */
                        cl_list_iterator_t  list_iterator;
                        uint64_t          * p_tmp_num;
                        uint8_t             sl;

                        list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                        p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                        if (*p_tmp_num > 15)
                        {
                            yyerror("illegal SL value");
                            return 1;
                        }

                        sl = (uint8_t)(*p_tmp_num);
                        free(p_tmp_num);
                        cl_list_remove_all(&tmp_parser_struct.num_list);

                        p_current_qos_match_rule->p_qos_level =
                                 &osm_qos_policy_simple_qos_levels[sl];
                        p_current_qos_match_rule->qos_level_name =
                                 strdup(osm_qos_policy_simple_qos_levels[sl].name);

                        if (__parser_ulp_match_rule_end())
                            return 1;
                    }
#line 2665 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1210 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'name' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->name)
                            {
                                yyerror("port-group has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2691 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1233 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2699 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1238 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'port-group' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_port_group->use)
                            {
                                yyerror("port-group has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_port_group->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2725 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1261 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2733 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1266 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'port-name' in 'port-group' - any num of instances */
                            cl_list_iterator_t list_iterator;
                            osm_node_t * p_node;
                            osm_physp_t * p_physp;
                            unsigned port_num;
                            char * tmp_str;
                            char * port_str;

                            /* parsing port name strings */
                            for (list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                                 list_iterator != cl_list_end(&tmp_parser_struct.str_list);
                                 list_iterator = cl_list_next(list_iterator))
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                {
                                    /* last slash in port name string is a separator
                                       between node name and port number */
                                    port_str = strrchr(tmp_str, '/');
                                    if (!port_str || (strlen(port_str) < 3) ||
                                        (port_str[1] != 'p' && port_str[1] != 'P')) {
                                        yyerror("'%s' - illegal port name",
                                                           tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    if (!(port_num = strtoul(&port_str[2],NULL,0))) {
                                        yyerror(
                                               "'%s' - illegal port number in port name",
                                               tmp_str);
                                        free(tmp_str);
                                        cl_list_remove_all(&tmp_parser_struct.str_list);
                                        return 1;
                                    }

                                    /* separate node name from port number */
                                    port_str[0] = '\0';

                                    if (st_lookup(p_qos_policy->p_node_hash,
                                                  (st_data_t)tmp_str,
                                                  (void *)&p_node))
                                    {
                                        /* we found the node, now get the right port */
                                        p_physp = osm_node_get_physp_ptr(p_node, port_num);
                                        if (!p_physp) {
                                            yyerror(
                                                   "'%s' - port number out of range in port name",
                                                   tmp_str);
                                            free(tmp_str);
                                            cl_list_remove_all(&tmp_parser_struct.str_list);
                                            return 1;
                                        }
                                        /* we found the port, now add it to guid table */
                                        __parser_add_port_to_port_map(&p_current_port_group->port_map,
                                                                      p_physp);
                                    }
                                    free(tmp_str);
                                }
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 2802 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1332 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2810 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1337 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'port-guid' in 'port-group' - any num of instances */
                            /* list of guid ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_guid_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2833 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1357 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2841 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1362 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'prefix' in 'port-group' - any num of instances */
                            /* list of prefix ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list)) {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr(
				    &tmp_parser_struct.num_pair_list,
                                    &range_arr,
                                    &range_len);

                                __parser_add_prefix_range_to_prefix_map(
                                    &p_current_port_group->prefix_map,
                                    range_arr,
                                    range_len);
                            }
                        }
#line 2864 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1382 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2872 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1387 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'GID' in 'port-group' - any num of instances */
                            /* list of GID ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list)) {
                                ib_gid_t ** range_arr;
                                unsigned range_len;

                                __gidrangelist2rangearr(
				    &tmp_parser_struct.num_pair_list,
                                    &range_arr,
                                    &range_len);
				__parser_add_gid_range_to_gid_map(
                                    &p_current_port_group->prefix_map,
                                    range_arr,
                                    range_len);
                            }
                        }
#line 2894 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1406 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2902 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1412 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'port-group' - any num of instances */
                            /* list of pkey ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                __parser_add_pkey_range_to_port_map(
                                                      &p_current_port_group->port_map,
                                                      range_arr,
                                                      range_len);
                            }
                        }
#line 2925 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1432 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2933 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1437 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'partition' in 'port-group' - any num of instances */
                            __parser_add_partition_list_to_port_map(
                                               &p_current_port_group->port_map,
                                               &tmp_parser_struct.str_list);
                        }
#line 2944 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1445 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2952 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1450 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'node-type' in 'port-group' - any num of instances */
                        }
#line 2960 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1455 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 2968 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1471 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_CA;
                        }
#line 2977 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1477 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_SWITCH;
                        }
#line 2986 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1483 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               OSM_QOS_POLICY_NODE_TYPE_ROUTER;
                        }
#line 2995 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1489 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            p_current_port_group->node_types |=
                               (OSM_QOS_POLICY_NODE_TYPE_CA |
                                OSM_QOS_POLICY_NODE_TYPE_SWITCH |
                                OSM_QOS_POLICY_NODE_TYPE_ROUTER);
                        }
#line 3006 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1497 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            osm_port_t * p_osm_port =
                                osm_get_port_by_guid(p_qos_policy->p_subn,
                                     p_qos_policy->p_subn->sm_port_guid);
                            if (p_osm_port)
                                __parser_add_port_to_port_map(
                                   &p_current_port_group->port_map,
                                   p_osm_port->p_physp);
                        }
#line 3020 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1519 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'group' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3040 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1536 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3048 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1541 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across' in 'vlarb-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_vlarb_scope->across_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3068 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1558 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3076 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1563 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vl-high-limit' in 'vlarb-scope' - one instance of one number */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * p_tmp_num;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_tmp_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (p_tmp_num)
                            {
                                p_current_vlarb_scope->vl_high_limit = (uint32_t)(*p_tmp_num);
                                p_current_vlarb_scope->vl_high_limit_set = TRUE;
                                free(p_tmp_num);
                            }

                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3097 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1581 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3105 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1586 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vlarb-high' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_high_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3125 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1603 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3133 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1608 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'vlarb-low' in 'vlarb-scope' - list of pairs of numbers with ':' and ',' */
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                    cl_list_insert_tail(&p_current_vlarb_scope->vlarb_low_list,num_pair);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3153 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1625 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3161 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1641 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'group' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->group_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3181 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1658 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3189 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1663 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,strdup(tmp_str));
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3211 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1682 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3219 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1687 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across-from' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_from_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3239 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1704 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3247 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1709 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'across-to' in 'sl2vl-scope' - any num of instances */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str) {
                                    cl_list_insert_tail(&p_current_sl2vl_scope->across_to_list,tmp_str);
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3268 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1727 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3276 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1732 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'from' in 'sl2vl-scope' - any num of instances */
                        }
#line 3284 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1737 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3292 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1742 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'to' in 'sl2vl-scope' - any num of instances */
                        }
#line 3300 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1747 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3308 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1756 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->from[i] = TRUE;
                        }
#line 3318 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1767 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            for (i = 0; i < OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH; i++)
                                p_current_sl2vl_scope->to[i] = TRUE;
                        }
#line 3328 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1774 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'from' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->from[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3362 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1805 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            int i;
                            cl_list_iterator_t    list_iterator;
                            uint64_t            * num_pair;
                            uint8_t               num1, num2;

                            list_iterator = cl_list_head(&tmp_parser_struct.num_pair_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_pair_list) )
                            {
                                num_pair = (uint64_t*)cl_list_obj(list_iterator);
                                if (num_pair)
                                {
                                    if ( num_pair[1] >= OSM_QOS_POLICY_MAX_PORTS_ON_SWITCH )
                                    {
                                        yyerror("port number out of range 'to' list");
                                        free(num_pair);
                                        cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                                        return 1;
                                    }
                                    num1 = (uint8_t)num_pair[0];
                                    num2 = (uint8_t)num_pair[1];
                                    free(num_pair);
                                    for (i = num1; i <= num2; i++)
                                        p_current_sl2vl_scope->to[i] = TRUE;
                                }
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.num_pair_list);
                        }
#line 3396 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1837 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'sl2vl-table' - one instance of exactly
                               OSM_QOS_POLICY_SL2VL_TABLE_LEN numbers */
                            cl_list_iterator_t    list_iterator;
                            uint64_t              num;
                            uint64_t            * p_num;
                            int                   i = 0;

                            if (p_current_sl2vl_scope->sl2vl_table_set)
                            {
                                yyerror("sl2vl-scope has more than one sl2vl-table");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            if (cl_list_count(&tmp_parser_struct.num_list) != OSM_QOS_POLICY_SL2VL_TABLE_LEN)
                            {
                                yyerror("wrong number of values in 'sl2vl-table' (should be 16)");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.num_list) )
                            {
                                p_num = (uint64_t*)cl_list_obj(list_iterator);
                                num = *p_num;
                                free(p_num);
                                if (num >= OSM_QOS_POLICY_MAX_VL_NUM)
                                {
                                    yyerror("wrong VL value in 'sl2vl-table' (should be 0 to 15)");
                                    cl_list_remove_all(&tmp_parser_struct.num_list);
                                    return 1;
                                }

                                p_current_sl2vl_scope->sl2vl_table[i++] = (uint8_t)num;
                                list_iterator = cl_list_next(list_iterator);
                            }
                            p_current_sl2vl_scope->sl2vl_table_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3442 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1880 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3450 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1897 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'name' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->name)
                            {
                                yyerror("qos-level has multiple 'name' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3476 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1920 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3484 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1925 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'qos-level' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_level->use)
                            {
                                yyerror("qos-level has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_level->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3510 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1948 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3518 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1953 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'sl' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->sl_set)
                            {
                                yyerror("'qos-level' has multiple 'sl' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->sl = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->sl_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3541 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1973 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3549 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1978 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->mtu_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'mtu-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_MTU || *p_num < OSM_QOS_POLICY_MIN_MTU)
                            {
                                yyerror("mtu limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->mtu_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->mtu_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3579 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 209:
#line 2005 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'mtu-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3588 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 210:
#line 2011 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->rate_limit_set)
                            {
                                yyerror("'qos-level' has multiple 'rate-limit' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            if (*p_num > OSM_QOS_POLICY_MAX_RATE || *p_num < OSM_QOS_POLICY_MIN_RATE)
                            {
                                yyerror("rate limit is out of range, value: %d", *p_num);
                                free(p_num);
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            p_current_qos_level->rate_limit = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->rate_limit_set = TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3618 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 211:
#line 2038 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'rate-limit' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3627 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 212:
#line 2044 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'packet-life' in 'qos-level' - one instance */
                            cl_list_iterator_t   list_iterator;
                            uint64_t           * p_num;

                            if (p_current_qos_level->pkt_life_set)
                            {
                                yyerror("'qos-level' has multiple 'packet-life' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }
                            list_iterator = cl_list_head(&tmp_parser_struct.num_list);
                            p_num = (uint64_t*)cl_list_obj(list_iterator);
                            p_current_qos_level->pkt_life = (uint8_t)(*p_num);
                            free(p_num);
                            p_current_qos_level->pkt_life_set= TRUE;
                            cl_list_remove_all(&tmp_parser_struct.num_list);
                        }
#line 3650 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 213:
#line 2064 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'packet-life' in 'qos-level' - one instance */
                            RESET_BUFFER;
                        }
#line 3659 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 214:
#line 2070 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'path-bits' in 'qos-level' - any num of instances */
                            /* list of path bit ranges */

                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->path_bits_range_len )
                                {
                                    p_current_qos_level->path_bits_range_arr = range_arr;
                                    p_current_qos_level->path_bits_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->path_bits_range_arr,
                                                      p_current_qos_level->path_bits_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->path_bits_range_arr = new_range_arr;
                                    p_current_qos_level->path_bits_range_len = new_range_len;
                                }
                            }
                        }
#line 3697 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 215:
#line 2105 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3705 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 216:
#line 2110 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'qos-level' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_level->pkey_range_len )
                                {
                                    p_current_qos_level->pkey_range_arr = range_arr;
                                    p_current_qos_level->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_level->pkey_range_arr,
                                                      p_current_qos_level->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_level->pkey_range_arr = new_range_arr;
                                    p_current_qos_level->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3741 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 217:
#line 2143 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3749 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 218:
#line 2160 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'use' of 'qos-match-rule' - one instance */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            if (p_current_qos_match_rule->use)
                            {
                                yyerror("'qos-match-rule' has multiple 'use' tags");
                                cl_list_remove_all(&tmp_parser_struct.str_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->use = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3775 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 219:
#line 2183 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3783 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 220:
#line 2188 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'qos-class' in 'qos-match-rule' - num of instances of list of ranges */
                            /* list of class ranges (QoS Class is 12-bit value) */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->qos_class_range_len )
                                {
                                    p_current_qos_match_rule->qos_class_range_arr = range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->qos_class_range_arr,
                                                      p_current_qos_match_rule->qos_class_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->qos_class_range_arr = new_range_arr;
                                    p_current_qos_match_rule->qos_class_range_len = new_range_len;
                                }
                            }
                        }
#line 3820 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 221:
#line 2222 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3828 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 222:
#line 2227 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'source' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->source_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3848 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 223:
#line 2244 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3856 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 224:
#line 2249 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'destination' in 'qos-match-rule' - text */
                            cl_list_iterator_t    list_iterator;
                            char                * tmp_str;

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            while( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    cl_list_insert_tail(&p_current_qos_match_rule->destination_list,tmp_str);
                                list_iterator = cl_list_next(list_iterator);
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3876 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 225:
#line 2266 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3884 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 226:
#line 2271 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'qos-level-name' in 'qos-match-rule' - single string */
                            cl_list_iterator_t   list_iterator;
                            char               * tmp_str;

                            if (p_current_qos_match_rule->qos_level_name)
                            {
                                yyerror("qos-match-rule has multiple 'qos-level-name' tags");
                                cl_list_remove_all(&tmp_parser_struct.num_list);
                                return 1;
                            }

                            list_iterator = cl_list_head(&tmp_parser_struct.str_list);
                            if ( list_iterator != cl_list_end(&tmp_parser_struct.str_list) )
                            {
                                tmp_str = (char*)cl_list_obj(list_iterator);
                                if (tmp_str)
                                    p_current_qos_match_rule->qos_level_name = tmp_str;
                            }
                            cl_list_remove_all(&tmp_parser_struct.str_list);
                        }
#line 3910 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 227:
#line 2294 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3918 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 228:
#line 2299 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'service-id' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->service_id_range_len )
                                {
                                    p_current_qos_match_rule->service_id_range_arr = range_arr;
                                    p_current_qos_match_rule->service_id_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->service_id_range_arr,
                                                      p_current_qos_match_rule->service_id_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->service_id_range_arr = new_range_arr;
                                    p_current_qos_match_rule->service_id_range_len = new_range_len;
                                }
                            }
                        }
#line 3954 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 229:
#line 2332 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 3962 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 230:
#line 2337 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            /* 'pkey' in 'qos-match-rule' - num of instances of list of ranges */
                            if (cl_list_count(&tmp_parser_struct.num_pair_list))
                            {
                                uint64_t ** range_arr;
                                unsigned range_len;

                                __pkey_rangelist2rangearr( &tmp_parser_struct.num_pair_list,
                                                      &range_arr,
                                                      &range_len );

                                if ( !p_current_qos_match_rule->pkey_range_len )
                                {
                                    p_current_qos_match_rule->pkey_range_arr = range_arr;
                                    p_current_qos_match_rule->pkey_range_len = range_len;
                                }
                                else
                                {
                                    uint64_t ** new_range_arr;
                                    unsigned new_range_len;
                                    __merge_rangearr( p_current_qos_match_rule->pkey_range_arr,
                                                      p_current_qos_match_rule->pkey_range_len,
                                                      range_arr,
                                                      range_len,
                                                      &new_range_arr,
                                                      &new_range_len );
                                    p_current_qos_match_rule->pkey_range_arr = new_range_arr;
                                    p_current_qos_match_rule->pkey_range_len = new_range_len;
                                }
                            }
                        }
#line 3998 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 231:
#line 2370 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                            RESET_BUFFER;
                        }
#line 4006 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 232:
#line 2381 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
                        cl_list_insert_tail(&tmp_parser_struct.str_list,
                                            strdup(__parser_strip_white(tmp_parser_struct.str)));
                        tmp_parser_struct.str[0] = '\0';
                    }
#line 4016 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 235:
#line 2392 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    {
			size_t str_len = strlen(tmp_parser_struct.str);
			size_t addition_len = strlen((yyvsp[0]));
			if ((str_len + addition_len) <= OSM_QOS_POLICY_MAX_LINE_LEN)
	                        strcat(tmp_parser_struct.str,(yyvsp[0]));
                    }
#line 4027 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 239:
#line 2408 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __make_num(num_tmp); }
#line 4033 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 240:
#line 2411 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __make_num(num_tmp); }
#line 4039 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 241:
#line 2414 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_str2uint64(&num_tmp, (yyvsp[0])); }
#line 4045 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 244:
#line 2423 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { num_1 = num_tmp; }
#line 4051 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 245:
#line 2423 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { num_2 = num_tmp;  __make_num_pair(num_1, num_2, FALSE); }
#line 4057 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 249:
#line 2435 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { num_1 = num_tmp; }
#line 4063 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 250:
#line 2435 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { num_2 = num_tmp;  __make_num_pair(num_1, num_2, TRUE); }
#line 4069 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 251:
#line 2436 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { num_1 = num_tmp;                    num_2 = num_1;    __make_num_pair(num_1, num_2, TRUE); }
#line 4075 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 255:
#line 2448 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { gid_1 = gid_tmp; }
#line 4081 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 256:
#line 2448 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { gid_2 = gid_tmp;  __make_gid_pair(gid_1, gid_2); }
#line 4087 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 257:
#line 2449 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { gid_1 = gid_tmp;                 gid_2 = gid_1;    __make_gid_pair(gid_1, gid_2); }
#line 4093 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;

  case 258:
#line 2452 "./osm_qos_parser_y.y" /* yacc.c:1646  */
    { __parser_str2gid(&gid_tmp, (yyvsp[0])); }
#line 4099 "./osm_qos_parser_y.c" /* yacc.c:1646  */
    break;


#line 4103 "./osm_qos_parser_y.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2454 "./osm_qos_parser_y.y" /* yacc.c:1906  */


/***************************************************
 ***************************************************/

int osm_qos_parse_policy_file(IN osm_subn_t * p_subn)
{
    int res = 0;
    static boolean_t first_time = TRUE;
    p_qos_parser_osm_log = &p_subn->p_osm->log;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    osm_qos_policy_destroy(p_subn->p_qos_policy);
    p_subn->p_qos_policy = NULL;

    if (!p_subn->opt.qos_policy_file) {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_VERBOSE,
                "QoS policy file not specified\n");
        res = 1;
        goto Exit;
    }

    __qos_parser_in = fopen (p_subn->opt.qos_policy_file, "r");
    if (!__qos_parser_in)
    {
        if (strcmp(p_subn->opt.qos_policy_file,OSM_DEFAULT_QOS_POLICY_FILE)) {
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC01: "
                    "Failed opening QoS policy file %s - %s\n",
                    p_subn->opt.qos_policy_file, strerror(errno));
            res = 1;
        }
        else
            OSM_LOG(p_qos_parser_osm_log, OSM_LOG_VERBOSE,
                    "QoS policy file not found (%s)\n",
                    p_subn->opt.qos_policy_file);

        goto Exit;
    }

    if (first_time)
    {
        first_time = FALSE;
        __setup_simple_qos_levels();
        __setup_ulp_match_rules();
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_INFO,
		"Loading QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
    }
    else
        /*
         * ULP match rules list was emptied at the end of
         * previous parsing iteration.
         * What's left is to clear simple QoS levels.
         */
        __clear_simple_qos_levels();

    column_num = 1;
    line_num = 1;

    p_subn->p_qos_policy = osm_qos_policy_create(p_subn);

    __parser_tmp_struct_init();
    p_qos_policy = p_subn->p_qos_policy;

    /*
     * Call the parser.  When it returns, we destroy the
     * parser so that the next time it is called, it will be
     * from a clean setup.
     */
    res = yyparse();
    fclose(__qos_parser_in);
    __qos_parser_in = NULL;
    __qos_parser_lex_destroy();

    /*
     * Since we finished with the parser for now, we also
     * need to cleanup the temporary variables which it uses.
     */
    __parser_tmp_struct_destroy();

    if (res != 0)
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC03: "
                "Failed parsing QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
        osm_qos_policy_port_group_destroy(p_current_port_group);
        res = 1;
        goto Exit;
    }

    /* add generated ULP match rules to the usual match rules */
    __process_ulp_match_rules();

    if (osm_qos_policy_validate(p_subn->p_qos_policy,p_qos_parser_osm_log))
    {
        OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC04: "
                "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        fprintf(stderr, "Error(s) in QoS policy file (%s)\n",
                p_subn->opt.qos_policy_file);
        osm_qos_policy_destroy(p_subn->p_qos_policy);
        p_subn->p_qos_policy = NULL;
        res = 1;
    }

Exit:
    OSM_LOG_EXIT(p_qos_parser_osm_log);
    return res;
}

/***************************************************
 ***************************************************/

static void yyerror(const char *format, ...)
{
    char s[256];
    va_list pvar;

    OSM_LOG_ENTER(p_qos_parser_osm_log);

    free(__qos_parser_lval);
    __qos_parser_lval = NULL;

    va_start(pvar, format);
    vsnprintf(s, sizeof(s), format, pvar);
    va_end(pvar);

    OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC05: "
            "Syntax error (line %d:%d): %s\n",
            line_num, column_num, s);
    fprintf(stderr, "Error in QoS Policy File (line %d:%d): %s.\n",
            line_num, column_num, s);
    OSM_LOG_EXIT(p_qos_parser_osm_log);
}

/***************************************************
 ***************************************************/

static char * __parser_strip_white(char * str)
{
	char *p;

	while (isspace(*str))
		str++;
	if (!*str)
		return str;
	p = str + strlen(str) - 1;
	while (isspace(*p))
		*p-- = '\0';

	return str;
}

/***************************************************
 ***************************************************/

static void __make_num(uint64_t num)
{
    uint64_t *p_num = (uint64_t*)malloc(sizeof(uint64_t));
    *p_num = num;
    cl_list_insert_tail(&tmp_parser_struct.num_list, p_num);
}

static void __make_num_pair(uint64_t num_1, uint64_t num_2, boolean_t order)
{
    uint64_t * num_pair = (uint64_t*)malloc(sizeof(uint64_t)*2);
    if (!order || (num_1 <= num_2)) {
        num_pair[0] = num_1;
        num_pair[1] = num_2;
    } else {
        num_pair[0] = num_2;
        num_pair[1] = num_1;
    }
    cl_list_insert_tail(&tmp_parser_struct.num_pair_list, num_pair);
}

static void __parser_str2uint64(uint64_t * p_val, char * str)
{
   *p_val = strtoull(str, NULL, 0);
}

/***************************************************
 ***************************************************/

static void __parser_port_group_start()
{
    p_current_port_group = osm_qos_policy_port_group_create();
}

/***************************************************
 ***************************************************/

static int __parser_port_group_end()
{
    if(!p_current_port_group->name)
    {
        yyerror("port-group validation failed - no port group name specified");
        return -1;
    }

    if (p_current_port_group) {
	cl_list_insert_tail(&p_qos_policy->port_groups,
	                    p_current_port_group);
	p_current_port_group = NULL;
    }

    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_vlarb_scope_start()
{
    p_current_vlarb_scope = osm_qos_policy_vlarb_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_vlarb_scope_end()
{
    if ( !cl_list_count(&p_current_vlarb_scope->group_list) &&
         !cl_list_count(&p_current_vlarb_scope->across_list) )
    {
        yyerror("vlarb-scope validation failed - no port groups specified by 'group' or by 'across'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->vlarb_tables,
                        p_current_vlarb_scope);
    p_current_vlarb_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_sl2vl_scope_start()
{
    p_current_sl2vl_scope = osm_qos_policy_sl2vl_scope_create();
}

/***************************************************
 ***************************************************/

static int __parser_sl2vl_scope_end()
{
    if (!p_current_sl2vl_scope->sl2vl_table_set)
    {
        yyerror("sl2vl-scope validation failed - no sl2vl table specified");
        return -1;
    }
    if ( !cl_list_count(&p_current_sl2vl_scope->group_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_to_list) &&
         !cl_list_count(&p_current_sl2vl_scope->across_from_list) )
    {
        yyerror("sl2vl-scope validation failed - no port groups specified by 'group', 'across-to' or 'across-from'");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->sl2vl_tables,
                        p_current_sl2vl_scope);
    p_current_sl2vl_scope = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_qos_level_start()
{
    p_current_qos_level = osm_qos_policy_qos_level_create();
}

/***************************************************
 ***************************************************/

static int __parser_qos_level_end()
{
    if (!p_current_qos_level->sl_set)
    {
        yyerror("qos-level validation failed - no 'sl' specified");
        return -1;
    }
    if (!p_current_qos_level->name)
    {
        yyerror("qos-level validation failed - no 'name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_levels,
                        p_current_qos_level);
    p_current_qos_level = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_match_rule_end()
{
    if (!p_current_qos_match_rule->qos_level_name)
    {
        yyerror("match-rule validation failed - no 'qos-level-name' specified");
        return -1;
    }

    cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __parser_ulp_match_rule_start()
{
    p_current_qos_match_rule = osm_qos_policy_match_rule_create();
}

/***************************************************
 ***************************************************/

static int __parser_ulp_match_rule_end()
{
    OSM_ASSERT(p_current_qos_match_rule->p_qos_level);
    cl_list_insert_tail(&__ulp_match_rules,
                        p_current_qos_match_rule);
    p_current_qos_match_rule = NULL;
    return 0;
}

/***************************************************
 ***************************************************/

static void __make_gid_pair(ib_gid_t gid_1, ib_gid_t gid_2)
{
    ib_gid_t * gid_pair = (ib_gid_t *)malloc(sizeof(ib_gid_t)*2);

    if (__cmp_gids(gid_1, gid_2) < 1) {
        gid_pair[0] = gid_1;
        gid_pair[1] = gid_2;
    } else {
        gid_pair[0] = gid_2;
        gid_pair[1] = gid_1;
    }
    cl_list_insert_tail(&tmp_parser_struct.num_pair_list, gid_pair);
}

/* Address copied to p_val in network order. */
static void __parser_str2gid(ib_gid_t * p_val, char * str)
{
    inet_pton(AF_INET6, str, p_val);
}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_init()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_construct(&tmp_parser_struct.str_list);
    cl_list_init(&tmp_parser_struct.str_list, 10);
    cl_list_construct(&tmp_parser_struct.num_list);
    cl_list_init(&tmp_parser_struct.num_list, 10);
    cl_list_construct(&tmp_parser_struct.num_pair_list);
    cl_list_init(&tmp_parser_struct.num_pair_list, 10);
}

/***************************************************
 ***************************************************/

/*
 * Do NOT free objects from the temp struct.
 * Either they are inserted into the parse tree data
 * structure, or they are already freed when copying
 * their values to the parse tree data structure.
 */
static void __parser_tmp_struct_reset()
{
    tmp_parser_struct.str[0] = '\0';
    cl_list_remove_all(&tmp_parser_struct.str_list);
    cl_list_remove_all(&tmp_parser_struct.num_list);
    cl_list_remove_all(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

/*
 * The __parser_tmp_struct_destroy below needs to
 * free the items on the lists before destroying
 * the lists.  The cl_list_destroy call doesn't
 * actually free() items in the list.
 */
static void __parser_tmp_list_drain(cl_list_t *p_list)
{
    void *p_object;
    cl_list_iterator_t    list_iterator;

    list_iterator = cl_list_head(p_list);
    while (list_iterator != cl_list_end(p_list)) {
        p_object = (void *)cl_list_obj(list_iterator);
        free(p_object);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

}

/***************************************************
 ***************************************************/

static void __parser_tmp_struct_destroy()
{
    __parser_tmp_list_drain(&tmp_parser_struct.str_list);
    cl_list_destroy(&tmp_parser_struct.str_list);

    __parser_tmp_list_drain(&tmp_parser_struct.num_list);
    cl_list_destroy(&tmp_parser_struct.num_list);

    __parser_tmp_list_drain(&tmp_parser_struct.num_pair_list);
    cl_list_destroy(&tmp_parser_struct.num_pair_list);
}

/***************************************************
 ***************************************************/

#define __SIMPLE_QOS_LEVEL_NAME "SimpleQoSLevel_SL"
#define __SIMPLE_QOS_LEVEL_DEFAULT_NAME "SimpleQoSLevel_DEFAULT"

static void __setup_simple_qos_levels()
{
    uint8_t i;
    char tmp_buf[30];
    memset(osm_qos_policy_simple_qos_levels, 0,
           sizeof(osm_qos_policy_simple_qos_levels));
    for (i = 0; i < 16; i++)
    {
        osm_qos_policy_simple_qos_levels[i].sl = i;
        osm_qos_policy_simple_qos_levels[i].sl_set = TRUE;
        sprintf(tmp_buf, "%s%u", __SIMPLE_QOS_LEVEL_NAME, i);
        osm_qos_policy_simple_qos_levels[i].name = strdup(tmp_buf);
    }

    memset(&__default_simple_qos_level, 0,
           sizeof(__default_simple_qos_level));
    __default_simple_qos_level.name =
           strdup(__SIMPLE_QOS_LEVEL_DEFAULT_NAME);
}

/***************************************************
 ***************************************************/

static void __clear_simple_qos_levels()
{
    /*
     * Simple QoS levels are static.
     * What's left is to invalidate default simple QoS level.
     */
    __default_simple_qos_level.sl_set = FALSE;
}

/***************************************************
 ***************************************************/

static void __setup_ulp_match_rules()
{
    cl_list_construct(&__ulp_match_rules);
    cl_list_init(&__ulp_match_rules, 10);
}

/***************************************************
 ***************************************************/

static void __process_ulp_match_rules()
{
    cl_list_iterator_t list_iterator;
    osm_qos_match_rule_t *p_qos_match_rule = NULL;

    list_iterator = cl_list_head(&__ulp_match_rules);
    while (list_iterator != cl_list_end(&__ulp_match_rules))
    {
        p_qos_match_rule = (osm_qos_match_rule_t *) cl_list_obj(list_iterator);
        if (p_qos_match_rule)
            cl_list_insert_tail(&p_qos_policy->qos_match_rules,
                                p_qos_match_rule);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(&__ulp_match_rules);
}

/***************************************************
 ***************************************************/

static int __cmp_num_range(const void * p1, const void * p2)
{
    uint64_t * pair1 = *((uint64_t **)p1);
    uint64_t * pair2 = *((uint64_t **)p2);

    if (pair1[0] < pair2[0])
        return -1;
    if (pair1[0] > pair2[0])
        return 1;

    if (pair1[1] < pair2[1])
        return -1;
    if (pair1[1] > pair2[1])
        return 1;

    return 0;
}

/***************************************************
 ***************************************************/

static void __sort_reduce_rangearr(
    uint64_t  **   arr,
    unsigned       arr_len,
    uint64_t  ** * p_res_arr,
    unsigned     * p_res_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned last_valid_ind = 0;
    unsigned valid_cnt = 0;
    uint64_t ** res_arr;
    boolean_t * is_valid_arr;

    *p_res_arr = NULL;
    *p_res_arr_len = 0;

    qsort(arr, arr_len, sizeof(uint64_t*), __cmp_num_range);

    is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
    is_valid_arr[last_valid_ind] = TRUE;
    valid_cnt++;
    for (i = 1; i < arr_len; i++)
    {
        if (arr[i][0] <= arr[last_valid_ind][1])
        {
            if (arr[i][1] > arr[last_valid_ind][1])
                arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else if ((arr[i][0] - 1) == arr[last_valid_ind][1])
        {
            arr[last_valid_ind][1] = arr[i][1];
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        }
        else
        {
            is_valid_arr[i] = TRUE;
            last_valid_ind = i;
            valid_cnt++;
        }
    }

    res_arr = (uint64_t **)malloc(valid_cnt * sizeof(uint64_t *));
    for (i = 0; i < arr_len; i++)
    {
        if (is_valid_arr[i])
            res_arr[j++] = arr[i];
    }
    free(is_valid_arr);
    free(arr);

    *p_res_arr = res_arr;
    *p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/

inline static int __cmp_gids(ib_gid_t gid1, ib_gid_t gid2)
{
    uint64_t prefix1 = cl_ntoh64(gid1.unicast.prefix),
        prefix2 = cl_ntoh64(gid2.unicast.prefix),
        guid1 = cl_ntoh64(gid1.unicast.interface_id),
        guid2 = cl_ntoh64(gid2.unicast.interface_id);

    if (prefix1 < prefix2)
        return -1;
    if (prefix1 > prefix2)
        return 1;
    if (guid1 < guid2)
        return -1;
    if (guid1 > guid2)
        return 1;

    return 0;
}

/***************************************************
 ***************************************************/

static int __cmp_gid_range(const void * p1, const void * p2)
{
    ib_gid_t * pair1 = *((ib_gid_t **)p1);
    ib_gid_t * pair2 = *((ib_gid_t **)p2);
    int cmp;

    cmp = __cmp_gids(pair1[0], pair2[0]);
    return cmp ? cmp : __cmp_gids(pair1[1], pair2[1]);
}

/***************************************************
 ***************************************************/

static void __sort_reduce_gidrangearr(
    ib_gid_t  **   arr,
    unsigned       arr_len,
    ib_gid_t  ** * p_res_arr,
    unsigned     * p_res_arr_len)
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned last_valid_ind = 0;
    unsigned valid_cnt = 0;
    ib_gid_t ** res_arr;
    boolean_t * is_valid_arr;
    ib_gid_t prev_gid;

    *p_res_arr = NULL;
    *p_res_arr_len = 0;

    /* Sort pairs by 1st elements, or by 2nd element if 1st are equal */
    qsort(arr, arr_len, sizeof(ib_gid_t*), __cmp_gid_range);

    is_valid_arr = (boolean_t *)malloc(arr_len * sizeof(boolean_t));
    is_valid_arr[last_valid_ind] = TRUE;
    valid_cnt++;
    for (i = 1; i < arr_len; i++) {
        /* 1st range: arr[last_valid_ind], 2nd range: arr[i] */
        if (__cmp_gids(arr[i][0], arr[last_valid_ind][1]) < 1) {
            /* 2nd range start is within 1st range */
            if (__cmp_gids(arr[i][1], arr[last_valid_ind][1]) == 1) {
                /* 2nd range end is also within 1st range */
                arr[last_valid_ind][1] = arr[i][1];
            }
            free(arr[i]);
            arr[i] = NULL;
            is_valid_arr[i] = FALSE;
        } else {
            prev_gid.unicast.prefix = arr[i][0].unicast.prefix;
            prev_gid.unicast.interface_id =
                cl_hton64(cl_ntoh64(arr[i][0].unicast.interface_id) - 1);
            if (!__cmp_gids(prev_gid, arr[last_valid_ind][1])) {
                /* ranges are continuous */
                arr[last_valid_ind][1] = arr[i][1];
                free(arr[i]);
                arr[i] = NULL;
                is_valid_arr[i] = FALSE;
            } else {
                is_valid_arr[i] = TRUE;
                last_valid_ind = i;
                valid_cnt++;
            }
        }
    }

    /* Return a fixed array contains the valid values, sorted */
    res_arr = (ib_gid_t **)malloc(valid_cnt * sizeof(ib_gid_t *));
    for (i = 0; i < arr_len; i++) {
        if (is_valid_arr[i])
            res_arr[j++] = arr[i];
    }
    free(is_valid_arr);
    free(arr);

    *p_res_arr = res_arr;
    *p_res_arr_len = valid_cnt;
}

/***************************************************
 ***************************************************/
static void __pkey_rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    uint64_t   tmp_pkey;
    uint64_t * p_pkeys;
    cl_list_iterator_t list_iterator;

    list_iterator= cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       p_pkeys = (uint64_t *)cl_list_obj(list_iterator);
       p_pkeys[0] &= 0x7fff;
       p_pkeys[1] &= 0x7fff;
       if (p_pkeys[0] > p_pkeys[1])
       {
           tmp_pkey = p_pkeys[1];
           p_pkeys[1] = p_pkeys[0];
           p_pkeys[0] = tmp_pkey;
       }
       list_iterator = cl_list_next(list_iterator);
    }

    __rangelist2rangearr(p_list, p_arr, p_arr_len);
}

/***************************************************
 ***************************************************/

static void __rangelist2rangearr(
    cl_list_t    * p_list,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    cl_list_iterator_t list_iterator;
    unsigned len = cl_list_count(p_list);
    unsigned i = 0;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    list_iterator = cl_list_head(p_list);
    while( list_iterator != cl_list_end(p_list) )
    {
       tmp_arr[i++] = (uint64_t *)cl_list_obj(list_iterator);
       list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __gidrangelist2rangearr(
    cl_list_t    * p_list,
    ib_gid_t  ** * p_arr,
    unsigned     * p_arr_len)
{
    cl_list_iterator_t list_iterator;
    unsigned len = cl_list_count(p_list);
    unsigned i = 0;
    ib_gid_t **tmp_arr;
    ib_gid_t **res_arr = NULL;
    unsigned res_arr_len = 0;

    tmp_arr = (ib_gid_t **)malloc(len * sizeof(ib_gid_t *));

    list_iterator = cl_list_head(p_list);
    while (list_iterator != cl_list_end(p_list)) {
        tmp_arr[i++] = (ib_gid_t *)cl_list_obj(list_iterator);
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);

    __sort_reduce_gidrangearr(tmp_arr,
                              len,
                              &res_arr,
                              &res_arr_len);
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}
/***************************************************
 ***************************************************/

static void __merge_rangearr(
    uint64_t  **   range_arr_1,
    unsigned       range_len_1,
    uint64_t  **   range_arr_2,
    unsigned       range_len_2,
    uint64_t  ** * p_arr,
    unsigned     * p_arr_len )
{
    unsigned i = 0;
    unsigned j = 0;
    unsigned len = range_len_1 + range_len_2;
    uint64_t ** tmp_arr;
    uint64_t ** res_arr = NULL;
    unsigned res_arr_len = 0;

    *p_arr = NULL;
    *p_arr_len = 0;

    tmp_arr = (uint64_t **)malloc(len * sizeof(uint64_t *));

    for (i = 0; i < range_len_1; i++)
       tmp_arr[j++] = range_arr_1[i];
    for (i = 0; i < range_len_2; i++)
       tmp_arr[j++] = range_arr_2[i];
    free(range_arr_1);
    free(range_arr_2);

    __sort_reduce_rangearr( tmp_arr,
                            len,
                            &res_arr,
                            &res_arr_len );
    *p_arr = res_arr;
    *p_arr_len = res_arr_len;
}

/***************************************************
 ***************************************************/

static void __parser_add_port_to_port_map(
    cl_qmap_t   * p_map,
    osm_physp_t * p_physp)
{
    if (cl_qmap_get(p_map, cl_ntoh64(osm_physp_get_port_guid(p_physp))) ==
        cl_qmap_end(p_map))
    {
        osm_qos_port_t * p_port = osm_qos_policy_port_create(p_physp);
        if (p_port)
            cl_qmap_insert(p_map,
                           cl_ntoh64(osm_physp_get_port_guid(p_physp)),
                           &p_port->map_item);
    }
}

/***************************************************
 ***************************************************/

static void __parser_add_guid_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t guid_ho;
    osm_port_t * p_osm_port;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (guid_ho = range_arr[i][0]; guid_ho <= range_arr[i][1]; guid_ho++) {
             p_osm_port =
                osm_get_port_by_guid(p_qos_policy->p_subn, cl_hton64(guid_ho));
             if (p_osm_port)
                 __parser_add_port_to_port_map(p_map, p_osm_port->p_physp);
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_prefix_range_to_prefix_map(
    cl_qmap_t * p_map,
    uint64_t ** range_arr,
    unsigned range_len)
{
    unsigned i;
    uint64_t prefix;
    osm_qos_subnet_ports_t *p_item_prefix;

    if (!range_arr || !range_len)
	return;

    for (i = 0; i < range_len; i++) {
	for (prefix = range_arr[i][0]; prefix <= range_arr[i][1]; prefix++) {
		/* check if prefix map already exist */
		p_item_prefix = (osm_qos_subnet_ports_t *)cl_qmap_get(p_map, prefix);

		/* If there is no map for this prefix, create one */
		if ((cl_map_item_t *)p_item_prefix == cl_qmap_end(p_map)) {
		    p_item_prefix =
			 (osm_qos_subnet_ports_t *)calloc(1, sizeof(osm_qos_subnet_ports_t));
		    if (!p_item_prefix) {
			OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC0A: "
				"Could not allocate memory for prefix in port group\n");
			continue;
		    }

		    cl_qmap_init((cl_qmap_t *)p_item_prefix);
		    cl_qmap_init(&p_item_prefix->guid_map);

		    cl_qmap_insert(p_map, prefix, (cl_map_item_t *)p_item_prefix);
		} else if (cl_qmap_count(&p_item_prefix->guid_map)) {
			/*
			 * If prefix exists, empty the guid map, because all the
			 * subnet should be in group
			 */
			osm_qos_remove_items(&p_item_prefix->guid_map, FALSE);
		}
	}
	free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_insert_guid_range(
    cl_qmap_t * p_map,
    ib_gid_t gid1,
    ib_gid_t gid2)
{
    cl_map_item_t *p_map_item;
    uint64_t cur_guid,
	guid1 = cl_ntoh64(gid1.unicast.interface_id),
	guid2 = cl_ntoh64(gid2.unicast.interface_id);

    for (cur_guid = guid1; cur_guid <= guid2; cur_guid++) {
	p_map_item = (cl_map_item_t *)calloc(1, sizeof(cl_map_item_t));
	if (!p_map_item) {
		OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC08: "
			"Could not allocate memory for guid in port group\n");
		continue;
	}

	cl_qmap_insert(p_map, cur_guid, p_map_item);
    }

}

static void __parser_add_gid_range_to_gid_map(
    cl_qmap_t * p_map,
    ib_gid_t ** p_arr,
    unsigned range_len)
{
    uint64_t prefix;
    osm_qos_subnet_ports_t *p_item_prefix = NULL;
    uint64_t prev_prefix = 0;
    int i = 0;
    boolean_t new_prefix = FALSE;

    for (i = 0; i < range_len; i++) {
	prefix = cl_ntoh64((p_arr[i][0]).unicast.prefix);

	/* check if prefix map is already held from previous gid range */
	if (prev_prefix != prefix || !p_item_prefix)
	    p_item_prefix = (osm_qos_subnet_ports_t *)cl_qmap_get(p_map, prefix);
	prev_prefix = prefix;

	/* If there is no map for this prefix, create one */
	if ((cl_map_item_t *)p_item_prefix == cl_qmap_end(p_map)) {
	    p_item_prefix =
	        (osm_qos_subnet_ports_t *)calloc(1, sizeof(osm_qos_subnet_ports_t));
	    if (!p_item_prefix) {
		OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC09: "
			"Could not allocate memory for guid in port group\n");
		continue;
	    }
	    new_prefix = TRUE;

	    cl_qmap_init((cl_qmap_t *)p_item_prefix);
	    cl_qmap_init(&p_item_prefix->guid_map);

	    cl_qmap_insert(p_map, prefix, (cl_map_item_t *)p_item_prefix);
	}

	/*
	 * In case GUID map is empty and prefix already existed - whole subnet
	 * of prefix is a part of the port group, no need to add GUID.
	 */
	if (cl_qmap_count(&p_item_prefix->guid_map) != 0 || new_prefix) {
	    __parser_insert_guid_range(&p_item_prefix->guid_map,
				       p_arr[i][0], p_arr[i][1]);
	}
	new_prefix = FALSE;
	free(p_arr[i]);
    }
    free(p_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_pkey_range_to_port_map(
    cl_qmap_t  * p_map,
    uint64_t  ** range_arr,
    unsigned     range_len)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return;

    for (i = 0; i < range_len; i++) {
         for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
             pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
             p_prtn = (osm_prtn_t *)
                 cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);
             if (p_prtn != (osm_prtn_t *)cl_qmap_end(
                   &p_qos_policy->p_subn->prtn_pkey_tbl)) {
                 __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                 __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
             }
         }
         free(range_arr[i]);
    }
    free(range_arr);
}

/***************************************************
 ***************************************************/

static void __parser_add_partition_list_to_port_map(
    cl_qmap_t  * p_map,
    cl_list_t  * p_list)
{
    cl_list_iterator_t    list_iterator;
    char                * tmp_str;
    osm_prtn_t          * p_prtn;

    /* extract all the ports from the partition
       to the port map of this port group */
    list_iterator = cl_list_head(p_list);
    while(list_iterator != cl_list_end(p_list)) {
        tmp_str = (char*)cl_list_obj(list_iterator);
        if (tmp_str) {
            p_prtn = osm_prtn_find_by_name(p_qos_policy->p_subn, tmp_str);
            if (p_prtn) {
                __parser_add_map_to_port_map(p_map, &p_prtn->part_guid_tbl);
                __parser_add_map_to_port_map(p_map, &p_prtn->full_guid_tbl);
            }
            free(tmp_str);
        }
        list_iterator = cl_list_next(list_iterator);
    }
    cl_list_remove_all(p_list);
}

/***************************************************
 ***************************************************/

static void __parser_add_map_to_port_map(
    cl_qmap_t * p_dmap,
    cl_map_t  * p_smap)
{
    cl_map_iterator_t map_iterator;
    osm_physp_t * p_physp;

    if (!p_dmap || !p_smap)
        return;

    map_iterator = cl_map_head(p_smap);
    while (map_iterator != cl_map_end(p_smap)) {
        p_physp = (osm_physp_t*)cl_map_obj(map_iterator);
        __parser_add_port_to_port_map(p_dmap, p_physp);
        map_iterator = cl_map_next(map_iterator);
    }
}

/***************************************************
 ***************************************************/

static int __validate_pkeys( uint64_t ** range_arr,
                             unsigned    range_len,
                             boolean_t   is_ipoib)
{
    unsigned i;
    uint64_t pkey_64;
    ib_net16_t pkey;
    osm_prtn_t * p_prtn;

    if (!range_arr || !range_len)
        return 0;

    for (i = 0; i < range_len; i++) {
        for (pkey_64 = range_arr[i][0]; pkey_64 <= range_arr[i][1]; pkey_64++) {
            pkey = cl_hton16((uint16_t)(pkey_64 & 0x7fff));
            p_prtn = (osm_prtn_t *)
                cl_qmap_get(&p_qos_policy->p_subn->prtn_pkey_tbl, pkey);

            if (p_prtn == (osm_prtn_t *)cl_qmap_end(
                  &p_qos_policy->p_subn->prtn_pkey_tbl))
                p_prtn = NULL;

            if (is_ipoib) {
                /*
                 * Be very strict for IPoIB partition:
                 *  - the partition for the pkey have to exist
                 *  - it has to have at least 2 full members
                 */
                if (!p_prtn) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition doesn't exist",
                                       cl_ntoh16(pkey));
                    return 1;
                }
                else if (cl_map_count(&p_prtn->full_guid_tbl) < 2) {
                    yyerror("IPoIB partition, pkey 0x%04X - "
                                       "partition has less than two full members",
                                       cl_ntoh16(pkey));
                    return 1;
                }
            }
            else if (!p_prtn) {
                /*
                 * For non-IPoIB pkey we just want to check that
                 * the relevant partition exists.
                 * And even if it doesn't, don't exit - just print
                 * error message and continue.
                 */
                 OSM_LOG(p_qos_parser_osm_log, OSM_LOG_ERROR, "ERR AC02: "
			 "pkey 0x%04X - partition doesn't exist",
                         cl_ntoh16(pkey));
            }
        }
    }
    return 0;
}

/***************************************************
 ***************************************************/
